<template>
  <WEditor
    ref="editorRef"
    edit-mode
    :toolbar="!!message.details.isEditToolbar"
    :model-value="message.details.editMessageValue || message.content"
    @save="onSaveMessage"
    @cancel="onCancelEdit"
    @toolbar="setToolbarEditStatus(chatId, message.id, $event)"
    @update:modelValue="debounceUpdateEditMessage(chatId, message.id, $event.html)"
  >
    <template #reply>
      <ReplyMessage
        v-if="message.replyTo && !!message.details.isShowReplyInEditMessage"
        :message="message.replyTo"
        @remove="setShowingReplyInEditMessage(chatId, message.id, false)"
      />
    </template>
  </WEditor>

  <JDialog v-model="isShowConfirmDialog">
    <ConfirmCancelEditDialog
      @cancel="isShowConfirmDialog = false"
      @confirm="$emit('cancel')"
    />
  </JDialog>
</template>

<script setup lang="ts">
import { onMounted, PropType, ref } from 'vue';
import { JDialog } from '@new-jira-clone/ui/src/components';
import useDebounce from '@new-jira-clone/ui/src/composables/utils/useDebounce';
import {
  getShortContentFromMessage,
  ReplyMessage,
  useMessageDetailsService,
  useMessageStateService,
} from '@/entities/Message';
import { IEditMessageForm, IMessage } from '@/shared';
import { useChatSocket } from '@/shared/api';
import ConfirmCancelEditDialog from './ConfirmCancelEditDialog.vue';

const props = defineProps({
  chatId: {
    type: String,
    required: true,
  },
  message: {
    type: Object as PropType<IMessage>,
    required: true,
  },
});

const emits = defineEmits<{
  (event: 'cancel'): void;
}>();

const { editMessage } = useChatSocket();
const { updateMessage } = useMessageStateService();
const {
  setEditMessageValue,
  setToolbarEditStatus,
  setShowingReplyInEditMessage,
} = useMessageDetailsService();

const isShowConfirmDialog = ref(false);
// TODO: подумать как сюда добавить тип микросервиса WEditor
const editorRef = ref<any>(null);

const onSaveMessage = (message: { html: string; text: string }) => {
  const editedMessage: IEditMessageForm = {
    messageId: props.message.id,
    chatId: props.chatId,
    content: message.html,
    shortContent: getShortContentFromMessage(message.text),
  };

  if (!props.message.details.isShowReplyInEditMessage) {
    editedMessage.replyMessageId = null;
  }

  editMessage(editedMessage);

  updateMessage(
    {
      id: props.message.id,
      content: editedMessage.content,
      shortContent: editedMessage.shortContent,
      replyTo: props.message.details.isShowReplyInEditMessage ? props.message.replyTo : undefined,
      updatedAt: new Date().toISOString(),
    },
    props.chatId,
  );

  emits('cancel');
};

const onCancelEdit = () => {
  isShowConfirmDialog.value = true;
};

const debounceUpdateEditMessage = useDebounce(setEditMessageValue, 1000);

onMounted(() => {
  editorRef.value?.setFocus();
});
</script>
